package fi.er.opplugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.util.EventObject;

public class FinapbillBeforeF7SelectSample extends AbstractFormPlugin implements BeforeF7SelectListener {
    private static String nckd_apfinapbill = "nckd_apfinapbill"; //应付挂账单字段
    @Override
    public void registerListener(EventObject e) {
        //监听单据字段
        super.registerListener(e);
        RefBillEdit bill = this.getView().getControl(nckd_apfinapbill);
        bill.addBeforeF7SelectListener(this);
    }
    @Override
    public void beforeF7Select(BeforeF7SelectEvent arg0) {
        String fieldKey = arg0.getProperty().getName();
        if (StringUtils.equals(fieldKey, nckd_apfinapbill)){
            DynamicObject costcompany = (DynamicObject) this.getModel().getValue("costcompany");
            Long costcompanyId = costcompany.getLong("id");
            // 生成过滤条件对象QFilter
            QFilter qFilter = new QFilter("org", QCP.equals, costcompanyId);
            qFilter.and("nckd_selectflag", QCP.not_in, "1");
            // 设置列表过滤条件
            ListShowParameter showParameter = (ListShowParameter)arg0.getFormShowParameter();
            showParameter.getListFilterParameter().setFilter(qFilter);
        }
    }
}
